VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "API RichPad 1.0"
   ClientHeight    =   4575
   ClientLeft      =   180
   ClientTop       =   240
   ClientWidth     =   5775
   Icon            =   "BPARPAD1.frx":0000
   LinkTopic       =   "Form1"
   ScaleHeight     =   4575
   ScaleWidth      =   5775
   StartUpPosition =   2  'CenterScreen
   Begin VB.PictureBox Picture1 
      Height          =   300
      Left            =   2520
      Picture         =   "BPARPAD1.frx":030A
      ScaleHeight     =   240
      ScaleWidth      =   3120
      TabIndex        =   0
      Top             =   4200
      Visible         =   0   'False
      Width           =   3180
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Private ReDLL As Long, hStatus As Long, hRich As Long
Const OpenBox As Integer = 1, SaveBox As Integer = 2
Private Const WM_USER = &H400
 '   /
Private Enum UNDONAMEID
    UID_UNKNOWN = 0
    UID_TYPING = 1
    UID_DELETE = 2
    UID_DRAGDROP = 3
    UID_CUT = 4
    UID_PASTE = 5
End Enum

Private Sub Form_Activate()
 Focus hRich
 Const EM_AUTOURLDETECT = (WM_USER + 91)
  '      .
  '   .
 SendMessage hRich, EM_AUTOURLDETECT, 1&, ByVal 0&
End Sub

Private Sub Form_Load()
 'RICHED32.DLL
 ReDLL = LoadLibrary("RICHED20.DLL")
 InitCommonControls
 hRich = EditControl(Me.hwnd, 5, 5, 400, 400, 0)
 RichBoxCLS hRich

 '  
 Dim Panels(2) As Long ' 
 '   (-1 - )
 Panels(0) = 160: Panels(1) = 280: Panels(2) = -1
 hStatus = StatusBar(Me.hwnd, Panels())
 StatusBarSetText hStatus, 0, NoBorders, "cyraxua@hotmail.com"

 Const SYSTEM_FIXED_FONT As Long = 16
 Const WM_SETFONT As Long = &H30
 SendMessage hRich, WM_SETFONT, GetStockObject(SYSTEM_FIXED_FONT), ByVal 0&
 
 CreateToolBar Me
 
 '    WindowProcCB
 MessageThread = SetWindowLong(Form1.hwnd, GWL_WNDPROC, AddressOf WindowProcCB)
 '  RichTextBox  WindowProcCB
 hRichMsgTarget = SetWindowLong(hRich, GWL_WNDPROC, AddressOf WindowProcCB)
End Sub

Private Sub Form_Resize()
'      (Form1)
If hStatus <> 0 Then SendMessage hStatus, WM_SIZE, 0, ByVal 0&

SendMessage hToolBar, TB_AUTOSIZE, 0, 0 '  -    
DoEvents

'  RichEdit   Toolbar  Statusbar
Dim TBarRc As RECT, SBarRc As RECT
GetWindowRect hToolBar, TBarRc
GetWindowRect hStatus, SBarRc

RichTop = (TBarRc.Bottom - TBarRc.Top) + 1
RichWidth = (Me.ScaleWidth / Screen.TwipsPerPixelX) - 4
RichHeight = SBarRc.Top - RichTop
RichHeight = ((Me.ScaleHeight / Screen.TwipsPerPixelY) - ((TBarRc.Bottom - TBarRc.Top) + (SBarRc.Bottom - SBarRc.Top))) - 2
MoveWindow hRich, 2, RichTop, RichWidth, RichHeight, True
End Sub

Private Sub Form_Unload(Cancel As Integer)
 '    
 DestroyWindow hRich
 DestroyWindow hStatus
 DestroyWindow hToolBar

 '    RICHED20.DLL
 FreeLibrary ReDLL

 '     WindowProcCB
 SetWindowLong Form1.hwnd, GWL_WNDPROC, MessageThread
End Sub

Sub ToolBar_Click(Button As Integer)
Dim RetFile As RetOpenFile
 Select Case Button
 Case 1
  RichBoxCLS hRich
  StatusBarSetText hStatus, 1, Normal, " "
  StatusBarSetText hStatus, 2, Normal, "  "
Case 2
  RichBoxCLS hRich
  RetFile = GetFileName(Me.hwnd, OpenBox)
  If RetFile.FilePath = "" Then Exit Sub
  If RetFile.FilterIndex = 1 Then FFilterIndex = SF_TEXT Else FFilterIndex = SF_RTF
  retFileSize = LoadFile(RetFile.FilePath, FFilterIndex, hRich)
  StatusBarSetText hStatus, 1, Normal, " " & CStr(retFileSize) & " . "
  StatusBarSetText hStatus, 2, Normal, " " & CStr(RetFile.FileTitle) & " "
 Case 3
  RetFile = GetFileName(Me.hwnd, SaveBox)
  If RetFile.FilePath = "" Then Exit Sub
  If RetFile.FilterIndex = 1 Then FFilterIndex = SF_TEXT Else FFilterIndex = SF_RTF
  retFileSize = SaveToFile(RetFile.FilePath, FFilterIndex, hRich)
  StatusBarSetText hStatus, 1, Normal, " " & CStr(retFileSize) & " . "
  StatusBarSetText hStatus, 2, Normal, " " & CStr(RetFile.FileTitle) & " "
 Case 4 To 6
  RichTextBox_MenuClick Button
 Case 7 To 10
  QuickFormat Button - 6
 Case 11
  Format.Tag = hRich
  Format.Show 1
  DoEvents
  Focus hRich
 Case 12
  QuickFormat Button - 6
 End Select
End Sub
Sub QuickFormat(Index As Integer)
Dim QuickCharformat As CHARFORMAT2
 
QuickCharformat = GetFormat(hRich, QuickCharformat)

Select Case Index
Case 1
 QuickCharformat.dwMask = CFM_BOLD
 '     , 
 '   (OR) -   (AND).
 If QuickCharformat.dwEffects And CFM_BOLD Then QuickCharformat.dwEffects = 0 Else QuickCharformat.dwEffects = CFM_BOLD
Case 2
 QuickCharformat.dwMask = CFM_ITALIC
 If QuickCharformat.dwEffects And CFM_ITALIC Then QuickCharformat.dwEffects = 0 Else QuickCharformat.dwEffects = CFM_ITALIC
Case 3
 QuickCharformat.dwMask = CFM_UNDERLINE
 If QuickCharformat.dwEffects And CFM_UNDERLINE Then QuickCharformat.dwEffects = 0 Else QuickCharformat.dwEffects = CFM_UNDERLINE
Case 4
 QuickCharformat.dwMask = CFM_EFFECTS
 QuickCharformat.dwEffects = 0
Case 6
 QuickCharformat.dwMask = CFM_COLOR
 QuickCharformat.dwEffects = 0
 QuickCharformat.crTextColor = GetColor(Me.hwnd, QuickCharformat.crTextColor)
End Select

Const WM_USER = &H400
Const EM_SETCHARFORMAT As Long = (WM_USER + 68)
Const SCF_SELECTION As Long = &H1
SendMessage hRich, EM_SETCHARFORMAT, SCF_SELECTION, QuickCharformat
Focus hRich
End Sub
Function ToolBar_ToolTipText(ButtonNumber As Integer) As String
Select Case ButtonNumber
Case 1
 ToolBar_ToolTipText = ""
Case 2
 ToolBar_ToolTipText = ""
Case 3
 ToolBar_ToolTipText = ""
Case 4
 ToolBar_ToolTipText = ""
Case 5
 ToolBar_ToolTipText = ""
Case 6
 ToolBar_ToolTipText = ""
Case 7
 ToolBar_ToolTipText = ""
Case 8
 ToolBar_ToolTipText = ""
Case 9
 ToolBar_ToolTipText = ""
Case 10
 ToolBar_ToolTipText = " "
Case 11
 ToolBar_ToolTipText = ""
Case 12
 ToolBar_ToolTipText = ""
Case 13
 ToolBar_ToolTipText = " "
Case Else
 ToolBar_ToolTipText = ""
End Select
End Function
Function RichTextBox_hWnd() As Long
 RichTextBox_hWnd = hRich
End Function
Sub RichTextBox_MenuClick(Item As Integer)

'      RichEdit
Const EM_UNDO = &HC7
Const EM_REDO = (WM_USER + 84)
Const WM_CUT = &H300
Const WM_COPY = &H301
Const WM_PASTE = &H302
Const WM_CLEAR = &H303
Const EM_EXSETSEL = (WM_USER + 55)

 Select Case Item
 Case 1
  Emsg = EM_UNDO
 Case 2
  Emsg = EM_REDO
 Case 4
  Emsg = WM_CUT
 Case 5
  Emsg = WM_COPY
 Case 6
  Emsg = WM_PASTE
 Case 7
  Emsg = WM_CLEAR
 Case 9
  ' 
  Const EM_EXGETSEL As Long = (WM_USER + 52)
  Const WM_GETTEXTLENGTH = &HE
  '    RichEdit
  TextLength = SendMessage(hRich, WM_GETTEXTLENGTH, 0&, 0&)
  Dim lParam  As CHARRANGE '   RichEdit
  lParam.cpMin = 0: lParam.cpMax = TextLength
  Emsg = EM_EXSETSEL '   
 End Select

'     Item
SendMessage hRich, Emsg, wParam, lParam

End Sub
Function RichTextBox_MenuItemEnabled(Item As Byte) As Boolean
'       .

RichTextBox_MenuItemEnabled = True

Const iUndo = 1, iRedo = 2, iCut = 4, iCopy = 5, iPaste = 6, iDel = 7, iSelAll = 9
 
 Select Case Item
 Case iUndo
  Const EM_CANUNDO As Long = &HC6
  If SendMessage(hRich, EM_CANUNDO, 0&, 0&) = 0 Then RichTextBox_MenuItemEnabled = False
 Case iRedo
  Const EM_CANREDO As Long = (WM_USER + 85)
  If SendMessage(hRich, EM_CANREDO, 0&, 0&) = 0 Then RichTextBox_MenuItemEnabled = False
 Case iCut, iCopy, iDel
  Const EM_EXGETSEL As Long = (WM_USER + 52)
  Dim SelStartEnd As CHARRANGE
  SendMessage hRich, EM_EXGETSEL, 0&, SelStartEnd
  If SelStartEnd.cpMin = SelStartEnd.cpMax Then RichTextBox_MenuItemEnabled = False
 Case iPaste
  Const EM_CANPASTE As Long = (WM_USER + 50)
  If SendMessage(hRich, EM_CANPASTE, 0&, 0&) = 0 Then RichTextBox_MenuItemEnabled = False
 Case iSelAll
  Const WM_GETTEXTLENGTH = &HE
  If SendMessage(hRich, WM_GETTEXTLENGTH, 0&, 0&) = 0 Then RichTextBox_MenuItemEnabled = False
 Case Else
 End Select

End Function
Function RichTextBox_GetUndoRedo(Operation As Byte) As String
'    
'   
Select Case Operation
Case 0
 Const EM_GETUNDONAME As Long = (WM_USER + 86)
 URMessage = EM_GETUNDONAME
Case 1
 Const EM_GETREDONAME As Long = (WM_USER + 87)
 URMessage = EM_GETREDONAME
End Select
Dim URName As UNDONAMEID
URName = SendMessage(hRich, URMessage, 0&, 0&)
Select Case URName
Case UID_UNKNOWN
 RichTextBox_GetUndoRedo = " "
Case UID_TYPING
 RichTextBox_GetUndoRedo = " "
Case UID_DELETE
 RichTextBox_GetUndoRedo = ""
Case UID_DRAGDROP
 RichTextBox_GetUndoRedo = "  "
Case UID_CUT
 RichTextBox_GetUndoRedo = ""
Case UID_PASTE
 RichTextBox_GetUndoRedo = ""
Case Else
 RichTextBox_GetUndoRedo = " "
End Select
End Function
