Attribute VB_Name = "ToolBarM"
' BP API ToolBar 2.0 (cyraxua@hotmail.com,BP@pochtamt.com)

Public Const WM_USER = &H400

Public hToolBar As Long 'hWnd 
Public hToolTip As Long
Public msToolTipBuffer As String
Public Const TB_AUTOSIZE = (WM_USER + 33)

Public Type POINTAPI
        x As Long
        y As Long
End Type
Public Type msg
    hwnd As Long
    message As Long
    wParam As Long
    lParam As Long
    time As Long
    pt As POINTAPI
End Type
 Declare Function SetWindowLong Lib "user32" Alias "SetWindowLongA" (ByVal hwnd As Long, ByVal nIndex As Long, ByVal dwNewLong As Long) As Long
 Declare Function CallWindowProc Lib "user32" Alias "CallWindowProcA" (ByVal lpPrevWndFunc As Long, ByVal hwnd As Long, ByVal msg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
Public Const GWL_WNDPROC = (-4)
Public Const WM_COMMAND = &H111
Public MessageThread As Long

Public Type TBBUTTON
   iBitmap As Long
   idCommand As Long
   fsState As Byte
   fsStyle As Byte
   bReserved1 As Byte
   bReserved2 As Byte
   dwData As Long
   iString As Long
End Type
Public Declare Function CreateToolbarEx Lib "COMCTL32" (ByVal hwnd As Long, ByVal ws As Long, ByVal wID As Long, ByVal nBitmaps As Long, ByVal hBMInst As Long, ByVal wBMID As Long, ByRef lpButtons As TBBUTTON, ByVal iNumButtons As Long, ByVal dxButton As Long, ByVal dyButton As Long, ByVal dxBitmap As Long, ByVal dyBitmap As Long, ByVal uStructSize As Long) As Long
Public Declare Function SendMessage Lib "user32" Alias "SendMessageA" (ByVal hwnd As Long, ByVal wMsg As Long, ByVal wParam As Long, lParam As Any) As Long
Private Declare Function ShowWindow Lib "user32" (ByVal hwnd As Long, ByVal nCmdShow As Long) As Long
Private Type TBADDBITMAP
    hInst As Long
    nID As Long
End Type
Private Type BITMAP
    bmType As Long
    bmWidth As Long
    bmHeight As Long
    bmWidthBytes As Long
    bmPlanes As Integer
    bmBitsPixel As Integer
    bmBits As Long
End Type
Private Declare Function GetObject Lib "gdi32" Alias "GetObjectA" (ByVal hObject As Long, ByVal nCount As Long, lpObject As Any) As Long
Private Declare Function GetDC Lib "user32" (ByVal hwnd As Long) As Long
Private Declare Function CreateDC Lib "gdi32" Alias "CreateDCA" (ByVal lpDriverName As String, lpDeviceName As Any, lpOutput As Any, lpInitData As Any) As Long
Private Declare Function CreateCompatibleDC Lib "gdi32" (ByVal hdc As Long) As Long
Private Declare Function CreateCompatibleBitmap Lib "gdi32" (ByVal hdc As Long, ByVal nWidth As Long, ByVal nHeight As Long) As Long
Private Declare Function GetWindowDC Lib "user32" (ByVal hwnd As Long) As Long
Private Declare Function ReleaseDC Lib "user32" (ByVal hwnd As Long, ByVal hdc As Long) As Long
Private Declare Function SelectObject Lib "gdi32" (ByVal hdc As Long, ByVal hObject As Long) As Long
Private Declare Function BitBlt Lib "gdi32" (ByVal hDestDC As Long, ByVal x As Long, ByVal y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hSrcDC As Long, ByVal xSrc As Long, ByVal ySrc As Long, ByVal dwRop As Long) As Long
Private Declare Function DeleteDC Lib "gdi32" (ByVal hdc As Long) As Long
Private Declare Function GetSysColor Lib "user32" (ByVal nIndex As Long) As Long
Private Declare Function CreateSolidBrush Lib "gdi32" (ByVal crColor As Long) As Long
Private Declare Function GetPixel Lib "gdi32" (ByVal hdc As Long, ByVal x As Long, ByVal y As Long) As Long
Private Declare Function ExtFloodFill Lib "gdi32" (ByVal hdc As Long, ByVal x As Long, ByVal y As Long, ByVal crColor As Long, ByVal wFillType As Long) As Long
Private Declare Function DeleteObject Lib "gdi32" (ByVal hObject As Long) As Long

Private Const WS_CHILD = &H40000000
Private Const WS_CLIPSIBLINGS = &H4000000
Private Const SW_SHOW = 5

Private Type TBBUTTONINFO
   cbSize As Long
   dwMask As Long
   idCommand As Long
   iImage As Long
   fsState As Byte
   fsStyle As Byte
   cx As Integer
   lParam As Long
   pszText As Long
   cchText As Long
End Type

Public Const TBSTYLE_BUTTON = &H0
Public Const TBSTYLE_SEP = &H1

Public Const TBSTYLE_CHECK = &H2
Public Const TBSTYLE_GROUP = &H4
Public Const TBSTYLE_CHECKGROUP = (TBSTYLE_GROUP Or TBSTYLE_CHECK)
Public Const TBSTYLE_DROPDOWN = &H8
Public Const TBSTYLE_AUTOSIZE = &H10         '// automatically calculate the cx of the button
Public Const BTNS_WHOLEDROPDOWN = &H80 '??? IE5 only

Public Enum ECTBToolButtonSyle
    CTBNormal = TBSTYLE_BUTTON
    CTBSeparator = TBSTYLE_SEP
    CTBCheck = TBSTYLE_CHECK
    CTBCheckGroup = TBSTYLE_CHECKGROUP
    CTBDropDown = TBSTYLE_DROPDOWN
    CTBAutoSize = TBSTYLE_AUTOSIZE
    CTBDropDownArrow = BTNS_WHOLEDROPDOWN
End Enum
Private Type ButtonInfoStore
    wID As Integer
    iImage As Integer
    sTipText As String
    iTextIndexNum As Integer
    sCaption As String
    bShowText As Boolean
    idString As Long
    iLarge As Integer
    xWidth As Integer
    xHeight As Integer
    sKey As String
    eStyle As ECTBToolButtonSyle
    hSubMenu As Long
    hWndCapture As Long
    hWndParentOrig As Long
    bStretch As Boolean
    bControl As Boolean
End Type

Private Const TOOLTIPS_CLASS = "tooltips_class32"
Public Type NMHDR
   hwndFrom As Long
   idfrom As Long
   code As Long
End Type
Public Type ToolTipText
   hdr As NMHDR
   lpszText As Long
   szText As String * 80
   hInst As Long
   uFlags As Long
End Type

Public Type MSGFILTER
  NMHDR As NMHDR
  msg As Long
  wParam  As Long
  lParam  As Long
End Type

Public Const WS_CLIPCHILDREN = &H2000000
Public Const GWL_STYLE = (-16)
Public Declare Function GetWindowLong Lib "user32" Alias "GetWindowLongA" (ByVal hwnd As Long, ByVal nIndex As Long) As Long
Public Type RECT
        Left As Long
        Top As Long
        Right As Long
        Bottom As Long
End Type

Private Type TOOLINFO
   cbSize As Long
   uFlags As Long
   hwnd As Long
   uId As Long
   rct As RECT
   hInst As Long
   lpszText As Long
End Type

Private Const WM_NOTIFY As Long = &H4E
'Private Const TTN_NEEDTEXT As Long = TTN_GETDISPINFO
Private Const H_MAX As Long = &HFFFF + 1
Private Const TTN_NEEDTEXT = (H_MAX - 520&)

Public Function WindowProcCB(ByVal hwnd As Long, ByVal uMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
If hwnd = Form1.RichTextBox_hWnd Then
 If uMsg = WM_CONTEXTMENU Then
  uMsg = 0
  WindowProcCB = 0
  PopUpMenu hwnd, "&|&|-|&|&|&|&|-| &"
 End If
End If

'  WM_COMMAND (  )
If hwnd = Form1.hwnd Then
If uMsg = WM_COMMAND Then
 Select Case wParam '  TBBUTTON.idCommand
 Case 50 To 61
  Form1.ToolBar_Click (wParam - 49) '  TBBUTTON.idCommand  
 Case 62
  strAbout = "BP " & Chr(174) & " API RichPad 1.0" & Chr(13) & "CopyRight " & Chr(169) & " 2003 BP (CyRax)" & Chr(13) & Chr(13) & "cyraxua@hotmail.com" & Chr(13) & "BP@pochtamt.com" & vbCr & vbCr
  BTest = ":  " & vbCr & "Alex@vbnet.ru"
  MsgBox strAbout & BTest, 64, " "
 End Select
End If
'  WM_NOTIFY (  
If uMsg = WM_NOTIFY Then
 Dim hdr As NMHDR
 '  (lParam) (uMsg)
 '    hdr
 CopyMemory hdr, ByVal lParam, Len(hdr)
 'hdr    ToolTipText
 If hdr.code = TTN_NEEDTEXT Then
  Dim ttt As ToolTipText
  BufferTTT$ = Form1.ToolBar_ToolTipText(hdr.idfrom - 49)
  msToolTipBuffer = StrConv(BufferTTT$, vbFromUnicode)
  msToolTipBuffer = msToolTipBuffer & vbNullChar
  CopyMemory ttt, ByVal lParam, Len(ttt)
  ttt.lpszText = StrPtr(ByVal msToolTipBuffer)
  CopyMemory ByVal lParam, ttt, Len(ttt)
 End If
End If
End If

'   (uMsg, wParam, lParam)   
If hwnd = Form1.hwnd Then WindowProcCB = CallWindowProc(MessageThread, hwnd, uMsg, wParam, lParam)
If hwnd = Form1.RichTextBox_hWnd Then WindowProcCB = CallWindowProc(hRichMsgTarget, hwnd, uMsg, wParam, lParam)
End Function

Public Sub AddToolBarButton(ToolBarHandle As Long, BitmapIndex, ButtonStyle, ButtonNumber, Optional Caption As String = "")
 Const TB_ADDBUTTONS = (WM_USER + 20) ' :  
 Const TBSTATE_ENABLED = &H4 '  : Enabled
 Dim TbButtonStruct As TBBUTTON '    " "

 '   
 TbButtonStruct.iBitmap = BitmapIndex
 TbButtonStruct.fsStyle = ButtonStyle
 TbButtonStruct.idCommand = ButtonNumber
 TbButtonStruct.fsState = TBSTATE_ENABLED
 
 '    (GoTo SkipIt)     
GoTo SkipIt
      Dim b() As Byte
      b = StrConv(Caption, vbFromUnicode)
      i = UBound(b) + 2
      ReDim Preserve b(0 To i) As Byte
      b(i - 1) = 0
      b(i) = 0
      Const TB_ADDSTRING = (WM_USER + 28)
 If ButtonNumber > 0 Then CaptionIndex = ButtonNumber - 50 Else CaptionIndex = 0
' If CaptionIndex > UBound(b) Then Exit Sub
 ID = SendMessage(hToolBar, TB_ADDSTRING, 0, b(0))
 TbButtonStruct.iString = ID
 
SkipIt:
 '  TB_ADDBUTTONS ( )
 SendMessage ToolBarHandle, TB_ADDBUTTONS, 1, TbButtonStruct
End Sub

Public Sub CreateToolBar(Form As Object)

Dim tbb As TBBUTTON '   " "
 ' 
 tbb.iBitmap = 0
 tbb.idCommand = 0
 tbb.fsState = TBSTATE_ENABLED
 tbb.fsStyle = TBSTYLE_SEP
 tbb.dwData = 0
 tbb.iString = 0

Const TBSTYLE_FLAT As Long = &H800
'  
Const TBSTYLE_TOOLTIPS = &H100
Const WS_CLIPCHILDREN = &H2000000
Const CCS_NOPARENTALIGN = &H8&
Const CCS_NORESIZE = &H4&
Const CCS_NODIVIDER = &H40&

hToolBar = CreateToolbarEx(Form.hwnd, WS_CHILD Or TBSTYLE_TOOLTIPS, 300, 1, 0, 0, tbb, 0, 16, 16, 0, 0, Len(tbb))

' 
ShowWindow hToolBar, SW_SHOW

'     (Flat)
Const GWL_STYLE = (-16)
lS = GetWindowLong(hToolBar, GWL_STYLE)
lS = lS Or TBSTYLE_FLAT
SetWindowLong hToolBar, GWL_STYLE, lS

Const STD_FILENEW = 6

Const HINST_COMMCTRL = -1& ' "   "
Const TB_ADDBITMAP = (WM_USER + 19) ':   

Dim tba As TBADDBITMAP '    "  "
tba.hInst = 0 ' 0:   
tba.nID = SetBmpColor(hBmpFromPicture(Form.Picture1)) '     (Handle of Bitmap)
SendMessage hToolBar, TB_ADDBITMAP, 1, tba ' :     tba

'       
'-tba.hInst = HINST_COMMCTRL
'-tba.nID = 1  ' btnsize 1=big 2=small
'-SendMessage hToolBar, TB_ADDBITMAP, IconNumber, tba


'    (ToolBar.hWnd,   , ,  )
AddToolBarButton hToolBar, 0, TBSTYLE_BUTTON, 50
AddToolBarButton hToolBar, 1, TBSTYLE_BUTTON, 51
AddToolBarButton hToolBar, 2, TBSTYLE_BUTTON, 52
AddToolBarButton hToolBar, -1, TBSTYLE_SEP, 0
AddToolBarButton hToolBar, 3, TBSTYLE_BUTTON, 53
AddToolBarButton hToolBar, 4, TBSTYLE_BUTTON, 54
AddToolBarButton hToolBar, 5, TBSTYLE_BUTTON, 55
AddToolBarButton hToolBar, -1, TBSTYLE_SEP, 0
AddToolBarButton hToolBar, 6, TBSTYLE_BUTTON, 56
AddToolBarButton hToolBar, 7, TBSTYLE_BUTTON, 57
AddToolBarButton hToolBar, 8, TBSTYLE_BUTTON, 58
AddToolBarButton hToolBar, 11, TBSTYLE_BUTTON, 59
AddToolBarButton hToolBar, -1, TBSTYLE_SEP, 0
AddToolBarButton hToolBar, 9, TBSTYLE_BUTTON, 60
AddToolBarButton hToolBar, 10, TBSTYLE_BUTTON, 61
AddToolBarButton hToolBar, -1, TBSTYLE_SEP, 0
AddToolBarButton hToolBar, 12, TBSTYLE_BUTTON, 62


'       .
' ,      CreateToolbarEx
'-Const TB_SETBITMAPSIZE As Long = (WM_USER + 32)
'-Dim MAKELONGxy As Long
'-MAKELONGxy = Width + (Height * &H10000)
'-SendMessage hToolBar, TB_SETBITMAPSIZE, 0, ByVal MAKELONGxy

ToolTipText hToolBar

End Sub
Public Function hBmpFromPicture(ipic As IPicture) As Long
'  
' vbAccelerator Toolbar control v3.0
' Copyright  1998-2000 Steve McMahon (steve@vbaccelerator.com)
'
' This is a complete form toolbar implementation designed
' for hosting in a vbAccelerator ReBar control.
'
' -------------------------------------------------------------------------
' Visit vbAccelerator at http://vbaccelerator.com

Dim lhDC1 As Long
Dim lhBmp1 As Long
Dim lhBmpOld1 As Long
Dim lhDC2 As Long
Dim lhBmp2 As Long
Dim lhBmpOld2 As Long
Dim lhDCDesktop As Long
Dim tBMP As BITMAP
   
   GetObject ipic.Handle, Len(tBMP), tBMP
   
   lhDCDesktop = CreateDC("DISPLAY", ByVal 0&, ByVal 0&, ByVal 0&)
   If (lhDCDesktop <> 0) Then
      lhDC1 = CreateCompatibleDC(lhDCDesktop)
      If lhDC1 <> 0 Then
         lhBmpOld1 = SelectObject(lhDC1, ipic.Handle)
      End If
      
      lhDC2 = CreateCompatibleDC(lhDCDesktop)
      If lhDC2 <> 0 Then
         lhBmp2 = CreateCompatibleBitmap(lhDCDesktop, tBMP.bmWidth, tBMP.bmHeight)
         lhBmpOld2 = SelectObject(lhDC2, lhBmp2)
      End If
      
      If lhDC1 <> 0 And lhBmp2 <> 0 Then
         BitBlt lhDC2, 0, 0, tBMP.bmWidth, tBMP.bmHeight, lhDC1, 0, 0, vbSrcCopy
      End If
      
      If lhBmp2 <> 0 Then
         SelectObject lhDC2, lhBmpOld2
         DeleteDC lhDC2
         hBmpFromPicture = lhBmp2
      End If
      
      If lhDC1 <> 0 Then
         SelectObject lhDC1, lhBmpOld1
         DeleteDC lhDC1
      End If
      
      DeleteDC lhDCDesktop
      
   End If

End Function

Function SetBmpColor(hBitmap As Long)
'  
' vbAccelerator Toolbar control v3.0
' Copyright  1998-2000 Steve McMahon (steve@vbaccelerator.com)
'
' This is a complete form toolbar implementation designed
' for hosting in a vbAccelerator ReBar control.
'
' -------------------------------------------------------------------------
' Visit vbAccelerator at http://vbaccelerator.com

Const COLOR_BTNFACE = 15
Const FLOODFILLSURFACE = 1
Dim mDC As Long, hBrush As Long, hOldBmp As Long, hOldBrush As Long

mDC = CreateCompatibleDC(0&)
hOldBmp = SelectObject(mDC, hBitmap)
hBrush = CreateSolidBrush(GetSysColor(COLOR_BTNFACE))
hOldBrush = SelectObject(mDC, hBrush)
ExtFloodFill mDC, 1, 1, GetPixel(mDC, 1, 1), FLOODFILLSURFACE

SelectObject mDC, hOldBrush
DeleteObject hBrush

SetBmpColor = SelectObject(mDC, hBitmap)
DeleteDC mDC

End Function
Public Sub ToolTipText(hWndParent As Long)
Const TOOLTIPS_CLASS = "tooltips_class32"
Const TTF_IDISHWND = &H1
Const LPSTR_TEXTCALLBACK As Long = -1
Const TTM_ADDTOOLA = (WM_USER + 4)
Const TTM_ADDTOOL = TTM_ADDTOOLA
Const TTM_DELTOOLA = (WM_USER + 5)
Const TTM_DELTOOL = TTM_DELTOOLA
Const TTM_ACTIVATE = (WM_USER + 1)

Dim tTi As TOOLINFO

Const WS_EX_TOPMOST As Long = &H8&
Const CW_USEDEFAULT As Long = &H80000000
If hToolTip = 0 Then
'   InitCommonControls
   hToolTip = CreateWindowEx(WS_EX_TOPMOST, TOOLTIPS_CLASS, vbNullString, 0, CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, 0, 0, App.hInstance, ByVal 0)
   SendMessage hToolTip, TTM_ACTIVATE, 1, ByVal 0
End If
    
   With tTi
      .cbSize = Len(tTi)
      .uId = hWndParent
      .hwnd = hWndParent
      .hInst = App.hInstance
      .uFlags = TTF_IDISHWND
      .lpszText = LPSTR_TEXTCALLBACK
   End With
   
   SendMessage hToolTip, TTM_ADDTOOL, 0, tTi
   SendMessage hToolTip, TTM_ACTIVATE, 1, 0
End Sub
