Attribute VB_Name = "Main"
Public Declare Function CreateWindowEx Lib "user32" Alias "CreateWindowExA" (ByVal dwExStyle As Long, ByVal lpClassName As String, ByVal lpWindowName As String, ByVal dwStyle As Long, ByVal x As Long, ByVal y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hWndParent As Long, ByVal hMenu As Long, ByVal hInstance As Long, lpParam As Any) As Long

Public Const WM_USER = &H400
Public Const WS_CHILD = &H40000000
Public Const WS_VISIBLE = &H10000000

Public Declare Function LoadLibrary Lib "kernel32" Alias "LoadLibraryA" (ByVal lpLibFileName As String) As Long
Public Declare Function FreeLibrary Lib "kernel32" (ByVal hLibModule As Long) As Long

Public Declare Function DestroyWindow Lib "user32" (ByVal hwnd As Long) As Long

Public Declare Sub InitCommonControls Lib "comctl32.dll" ()
'Public SP() As SB_PANEL_TYPE ' 

Public Declare Function SendMessage Lib "user32" Alias "SendMessageA" (ByVal hwnd As Long, ByVal wMsg As Long, ByVal wParam As Long, lParam As Any) As Long
Public Const WM_SETTEXT = &HC
Public Const EM_SETMODIFY = &HB9
Public Const WM_GETTEXT As Long = &HD

Public Declare Function GetWindowRect Lib "user32" (ByVal hwnd As Long, lpRect As RECT) As Long

Public Const WM_SIZE = &H5
Public Declare Function MoveWindow Lib "user32" (ByVal hwnd As Long, ByVal x As Long, ByVal y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal bRepaint As Long) As Long
Public Declare Function GetStockObject Lib "gdi32" (ByVal nIndex As Long) As Long

Declare Function GetLastError Lib "kernel32" () As Long
Public Declare Sub CopyMemory Lib "kernel32.dll" Alias "RtlMoveMemory" (Destination As Any, Source As Any, ByVal Length As Long)

Public Declare Function SetFocus Lib "user32.dll" (ByVal hwnd As Long) As Long
Private Declare Function LoadBitmap Lib "user32.dll" Alias "LoadBitmapA" (ByVal hInstance As Long, ByVal lpBitmapName As String) As Long

Public Declare Function SetWindowPos Lib "user32.dll" (ByVal hwnd As Long, ByVal hWndInsertAfter As Long, ByVal x As Long, ByVal y As Long, ByVal cx As Long, ByVal cy As Long, ByVal wFlags As Long) As Long

Public Declare Function GlobalAlloc Lib "kernel32.dll" (ByVal wFlags As Long, ByVal dwBytes As Long) As Long
Public Declare Function GlobalLock Lib "kernel32.dll" (ByVal hMem As Long) As Long
Public Declare Function GlobalUnlock Lib "kernel32.dll" (ByVal hMem As Long) As Long
Public Declare Function GlobalFree Lib "kernel32.dll" (ByVal hMem As Long) As Long
Public Const GMEM_MOVEABLE As Long = &H2
Public Const GMEM_ZEROINIT As Long = &H40

Public hRichMsgTarget As Long
Public Const WM_CONTEXTMENU As Long = &H7B

Private Declare Function CreatePopupMenu Lib "user32.dll" () As Long
Private Declare Function AppendMenu Lib "user32.dll" Alias "AppendMenuA" (ByVal hMenu As Long, ByVal wFlags As Long, ByVal wIDNewItem As Long, ByVal lpNewItem As Any) As Long
Private Declare Function TrackPopupMenu Lib "user32.dll" (ByVal hMenu As Long, ByVal wFlags As Long, ByVal x As Long, ByVal y As Long, ByVal nReserved As Long, ByVal hwnd As Long, lprc As Any) As Long
Private Declare Function DestroyMenu Lib "user32.dll" (ByVal hMenu As Long) As Long

Private Declare Function GetCursorPos Lib "user32.dll" (lpPoint As POINTAPI) As Long

Public Sub Focus(hwnd As Long)
 SetFocus hwnd
End Sub
Public Sub PopUpMenu(hWndParent As Long, ItemList As String)
ItemArray = Split(ItemList, "|")
Dim MousePoint As POINTAPI
Dim hMenuPopUp As Long, retMenu As Long

hMenuPopUpPopUp = CreatePopupMenu
For AddItems = 0 To UBound(ItemArray)
 If ItemArray(AddItems) <> "-" Then
  flags = 0
  Const MF_DISABLED As Long = &H2&, MF_GRAYED As Long = &H1&
  If Not Form1.RichTextBox_MenuItemEnabled(CByte(AddItems + 1)) Then
   flags = MF_DISABLED Or MF_GRAYED
  Else
   If AddItems = 0 Or AddItems = 1 Then ItemArray(AddItems) = ItemArray(AddItems) & " (" & Form1.RichTextBox_GetUndoRedo(CByte(AddItems)) & ")"
  End If
  AppendMenu hMenuPopUpPopUp, flags, AddItems + 1, CStr(ItemArray(AddItems))
 Else
  AppendMenu hMenuPopUpPopUp, &H800, 0, vbNull
 End If
Next AddItems

GetCursorPos MousePoint
retMenu = TrackPopupMenu(hMenuPopUpPopUp, 2 Or &H100, MousePoint.x, MousePoint.y, 0, hWndParent, 0)

If retMenu > 0 Then Form1.RichTextBox_MenuClick CInt(retMenu)
DestroyMenu lngMenu
End Sub
