Attribute VB_Name = "RichEd2"
Private Const ES_SUNKEN = &H4000
Private Const WS_CHILDWINDOW = (WS_CHILD)
Private Const ES_MULTILINE = &H4
Private Const WS_VSCROLL = &H200000
Private Const ES_AUTOVSCROLL = &H40
Private Const ES_NOHIDESEL = &H100
Private Const WS_HSCROLL = &H100000
Private Const ES_AUTOHSCROLL = &H80

Public Const OFS_MAXPATHNAME = 128
Public Type OFSTRUCT
        cBytes As Byte
        fFixedDisk As Byte
        nErrCode As Integer
        Reserved1 As Integer
        Reserved2 As Integer
        szPathName(OFS_MAXPATHNAME) As Byte
End Type
Private Declare Function CreateFile Lib "kernel32" Alias "CreateFileA" (ByVal lpFileName As String, ByVal dwDesiredAccess As Long, ByVal dwShareMode As Long, ByVal lpSecurityAttributes As Any, ByVal dwCreationDisposition As Long, ByVal dwFlagsAndAttributes As Long, ByVal hTemplateFile As Long) As Long
Private Const GENERIC_WRITE As Long = &H40000000
Private Const FILE_SHARE_READ As Long = &H1
Private Const FILE_SHARE_WRITE As Long = &H2
Private Const OPEN_ALWAYS As Long = 4
'Private Const GENERIC_READ As Long = &H80000000
'Private Const OPEN_EXISTING As Long = 3
Private Declare Function OpenFile Lib "kernel32" (ByVal lpFileName As String, lpReOpenBuff As OFSTRUCT, ByVal wStyle As Long) As Long
Private Declare Function ReadFile Lib "kernel32" (ByVal hFile As Long, lpBuffer As Any, ByVal nNumberOfBytesToRead As Long, lpNumberOfBytesRead As Long, lpOverlapped As Any) As Long
Private Declare Function WriteFile Lib "kernel32.dll" (ByVal hFile As Long, lpBuffer As Any, ByVal nNumberOfBytesToWrite As Long, lpNumberOfBytesWritten As Long, lpOverlapped As Any) As Long
Private Declare Function GetFileSize Lib "kernel32" (ByVal hFile As Long, lpFileSizeHigh As Long) As Long
Private Declare Function CloseHandle Lib "kernel32" (ByVal hObject As Long) As Long
'
Private Const LF_FACESIZE As Long = 32
Public Type CHARFORMAT2
    cbSize As Integer '2
    wPad1 As Integer  '4
    dwMask As Long    '8
    dwEffects As Long '12
    yHeight As Long   '16
    yOffset As Long   '20
    crTextColor As Long '24
    bCharSet As Byte    '25
    bPitchAndFamily As Byte '26
    szFaceName(0 To LF_FACESIZE - 1) As Byte ' 58
    wPad2 As Integer ' 60
    ' Additional stuff supported by RICHEDIT20
    wWeight As Integer            ' /* Font weight (LOGFONT value)      */
    sSpacing As Integer           ' /* Amount to space between letters  */
    crBackColor As Long        ' /* Background color                 */
    lLCID As Long               ' /* Locale ID                        */
    dwReserved As Long         ' /* Reserved. Must be 0              */
    sStyle As Integer            ' /* Style handle                     */
    wKerning As Integer            ' /* Twip size above which to kern char pair*/
    bUnderlineType As Byte     ' /* Underline type                   */
    bAnimation As Byte         ' /* Animated text like marching ants */
    bRevAuthor As Byte         ' /* Revision author index            */
    bReserved1 As Byte
End Type
'public Const CHARFORMATDELTA = (Len(CHARFORMAT2) - Len(CHARFORMAT))
Public Const CFM_ANIMATION = &H40000              ' /* (*)  */
Public Const CFM_BACKCOLOR = &H4000000
Public Const CFM_CHARSET = &H8000000
Public Const CFM_COLOR = &H40000000
Public Const CFM_FACE = &H20000000
Public Const CFM_KERNING = &H100000
Public Const CFM_LCID = &H2000000
Public Const CFM_OFFSET = &H10000000
Public Const CFM_REVAUTHOR = &H8000&
Public Const CFM_SIZE = &H80000000
Public Const CFM_SPACING = &H200000
Public Const CFM_STYLE = &H80000
Public Const CFM_UNDERLINETYPE = &H800000
Public Const CFM_WEIGHT As Long = &H400000

Public Const CFM_SMALLCAPS = &H40&
Public Const CFM_BOLD = &H1
Public Const CFM_DISABLED = &H2000&
Public Const CFM_EMBOSS = &H800&
Public Const CFM_HIDDEN = &H100&
Public Const CFM_IMPRINT = &H1000&
Public Const CFM_ITALIC = &H2
Public Const CFM_LINK = &H20&
Public Const CFM_OUTLINE = &H200&
Public Const CFM_PROTECTED = &H10
Public Const CFM_REVISED = &H4000&
Public Const CFM_SHADOW = &H400&
Public Const CFM_STRIKEOUT = &H8
Public Const CFE_SUBSCRIPT = &H10000
Public Const CFE_SUPERSCRIPT = &H20000
Public Const CFM_SUBSCRIPT = CFE_SUBSCRIPT Or CFE_SUPERSCRIPT
Public Const CFM_SUPERSCRIPT = CFM_SUBSCRIPT
Public Const CFM_UNDERLINE = &H4
Public Const CFM_ALLCAPS = &H80&                   ' /* (*)  */

Public Const CFU_CF1UNDERLINE = &HFF&      ' /* map charformat's bit underline to CF2.*/
Public Const CFU_INVERT = &HFE&            ' /* For IME composition fake a selection.*/
Public Const CFU_UNDERLINEDOTTED = &H4&    ' /* (*) displayed as ordinary underline  */
Public Const CFU_UNDERLINEDOUBLE = &H3&    ' /* (*) displayed as ordinary underline  */
Public Const CFU_UNDERLINEWORD = &H2&      ' /* (*) displayed as ordinary underline  */
Public Const CFU_UNDERLINE = &H1&
Public Const CFU_UNDERLINENONE = 0&

Public Form1Rich1Format As CHARFORMAT2
Public Const GetFormat1 As Integer = 1
Public Const SetFormat1 As Integer = 2

Public Const CFE_PROTECTED = &H10&
Public Const CFM_EFFECTS = (CFM_BOLD Or CFM_ITALIC Or CFM_UNDERLINE Or CFM_COLOR Or CFM_STRIKEOUT Or CFE_PROTECTED Or CFM_LINK)
Public Const CFM_ALL = (CFM_EFFECTS Or CFM_SIZE Or CFM_FACE Or CFM_OFFSET Or CFM_CHARSET)
Public Const CFM_EFFECTS2 = (CFM_EFFECTS Or CFM_DISABLED Or CFM_SMALLCAPS Or CFM_ALLCAPS _
                    Or CFM_HIDDEN Or CFM_OUTLINE Or CFM_SHADOW Or CFM_EMBOSS _
                    Or CFM_IMPRINT Or CFM_DISABLED Or CFM_REVISED _
                    Or CFM_SUBSCRIPT Or CFM_SUPERSCRIPT Or CFM_BACKCOLOR)

Public Const CFM_ALL2 = (CFM_ALL Or CFM_EFFECTS2 Or CFM_BACKCOLOR Or CFM_LCID _
                    Or CFM_UNDERLINETYPE Or CFM_WEIGHT Or CFM_REVAUTHOR _
                    Or CFM_SPACING Or CFM_KERNING Or CFM_STYLE Or CFM_ANIMATION)

Public Const ANSI_CHARSET As Long = 0
Public Const BALTIC_CHARSET As Long = 186
Public Const CHINESEBIG5_CHARSET As Long = 136
Public Const DEFAULT_CHARSET As Long = 1
Public Const EASTEUROPE_CHARSET As Long = 238
Public Const GB2312_CHARSET As Long = 134
Public Const GREEK_CHARSET As Long = 161
Public Const HANGUL_CHARSET As Long = 129
Public Const MAC_CHARSET As Long = 77
Public Const OEM_CHARSET As Long = 255
Public Const RUSSIAN_CHARSET As Long = 204
Public Const SHIFTJIS_CHARSET As Long = 128
Public Const SYMBOL_CHARSET As Long = 2
Public Const TURKISH_CHARSET As Long = 162
Public Const JOHAB_CHARSET As Long = 130
Public Const HEBREW_CHARSET As Long = 177
Public Const ARABIC_CHARSET As Long = 178
Public Const THAI_CHARSET As Long = 222

Public Const FF_DECORATIVE As Long = 80
Public Const FF_DONTCARE As Long = 0
Public Const FF_MODERN As Long = 48
Public Const FF_ROMAN As Long = 16
Public Const FF_SCRIPT As Long = 64
Public Const FF_SWISS As Long = 32
Public Const DEFAULT_PITCH As Long = 0
Public Const FIXED_PITCH As Long = 1
Public Const VARIABLE_PITCH As Long = 2

Public Const FW_DONTCARE = 0
Public Const FW_THIN = 100
Public Const FW_EXTRALIGHT = 200
'Public Const FW_ULTRALIGHT = 200
Public Const FW_LIGHT = 300
Public Const FW_NORMAL = 400
'Public Const FW_REGULAR = 400
Public Const FW_MEDIUM = 500
Public Const FW_SEMIBOLD = 600
'Public Const FW_DEMIBOLD = 600
Public Const FW_BOLD = 700
Public Const FW_EXTRABOLD = 800
'Public Const FW_ULTRABOLD = 800
Public Const FW_HEAVY = 900
'Public Const FW_BLACK = 900
'
Public Enum ERECFileTypes
    SF_TEXT = &H1
    SF_RTF = &H2
End Enum
Private m_sText As String
Private m_lPos As Long
Private m_lLen As Long
Private m_bFileMode As Boolean
Private m_lObj As Long
Private hWorkRich As Long
Public Type EDITSTREAM
    dwCookie As Long     ' /* user value passed to callback as first parameter */
    dwError As Long      ' /* last error */
    pfnCallback As Long  'EDITSTREAMCALLBACK
End Type
Public Const WM_USER = &H400
Public Const EM_STREAMOUT As Long = (WM_USER + 74)
'
Public Type CHARRANGE
    cpMin As Long
    cpMax As Long
End Type

Public Function EditControl(hParent, Left As Long, Top As Long, Width As Long, Height As Long, MenuID As Long) As Long
 'EditMl = "RICHEDIT"
 EditMl = "RichEdit20a":  hInstance = App.hInstance
 Const WS_EX_TRANSPARENT As Long = &H20&
 Const ES_WANTRETURN As Long = &H1000&
 Const WS_EX_CONTROLPARENT As Long = &H10000

EditControlTemp = CreateWindowEx(0&, "RichEdit20a", 0&, WS_VISIBLE Or ES_SUNKEN Or WS_CHILDWINDOW Or ES_MULTILINE Or WS_VSCROLL Or ES_AUTOVSCROLL Or ES_NOHIDESEL Or WS_HSCROLL Or ES_AUTOHSCROLL Or ES_WANTRETURN, Left, Top, Width, Height, hParent, ID, hInstance, Null)

EditControl = EditControlTemp
 'SendMessage hRich, EM_EXLIMITTEXT, 0, 100000000
End Function

Function GetFormat(HandleRichBox, BeginFormat As CHARFORMAT2) As CHARFORMAT2
Const EM_GETCHARFORMAT As Long = (WM_USER + 58)
Const EM_SETCHARFORMAT As Long = (WM_USER + 68)
Const CFM_CHARSET As Long = &H8000000
Const CFM_WEIGHT As Long = &H400000
Const CFM_STYLE As Long = &H80000
Const CFM_COLOR As Long = &H40000000

BeginFormat.cbSize = Len(BeginFormat)
'wParam = (WPARAM) (BOOL) fSelection;
'lParam = (LPARAM) (CHARFORMAT FAR *) lpFmt;
SendMessage HandleRichBox, EM_GETCHARFORMAT, ByVal True, BeginFormat
GetFormat = BeginFormat
End Function

Private Function plAddressOf(ByVal lAddr As Long) As Long
    
    ' Why do we have to write nonsense like this?
    plAddressOf = lAddr
End Function

Public Function SaveToFile(ByVal sFIle As String, ByVal eType As ERECFileTypes, ByVal hWndRich As Long) As Long
Dim tStream As EDITSTREAM
Dim tOF As OFSTRUCT
Dim hFile As Long
        
hWorkRich = hWndRich

Const OF_CREATE As Long = &H1000
   hFile = OpenFile(sFIle, tOF, OF_CREATE)
   If (hFile <> 0) Then
      tStream.dwCookie = hFile
      tStream.pfnCallback = plAddressOf(AddressOf SaveCallBack)
      tStream.dwError = 0
      
      lR = SendMessage(hWorkRich, EM_STREAMOUT, eType, tStream)
        If (lR <> 0) Then SaveToFile = GetFileSize(hFile, 0&) Else SaveToFile = -1
      
      CloseHandle hFile
   End If
       
End Function

Public Function SaveCallBack(ByVal dwCookie As Long, ByVal lPtrPbBuff As Long, ByVal cb As Long, ByVal pcb As Long) As Long
    WriteFile dwCookie, ByVal lPtrPbBuff, cb, ByVal pcb, ByVal 0&
    SaveCallBack = 0
End Function

Public Sub RichBoxCLS(Handle)
 SendMessage Handle, WM_SETTEXT, 0, 0
 SendMessage Handle, EM_SETMODIFY, 0, 0
End Sub

Public Function LoadFile(ByVal sFIle As String, ByVal eType As ERECFileTypes, ByVal hWndRich As Long) As Long
Dim tStream As EDITSTREAM
Dim tOF As OFSTRUCT
Dim hFile As Long
        
hWorkRich = hWndRich

 Const OF_READ = &H0
 hFile = OpenFile(sFIle, tOF, OF_READ)
   If (hFile <> 0) Then
      tStream.dwCookie = hFile
      tStream.pfnCallback = plAddressOf(AddressOf LoadCallBack)
      tStream.dwError = 0
      
        Const EM_STREAMIN = (WM_USER + 73)
        lR = SendMessage(hWorkRich, EM_STREAMIN, eType, tStream)
        If (lR <> 0) Then LoadFile = GetFileSize(hFile, 0&) Else LoadFile = -1
      
      CloseHandle hFile
   End If
       
End Function

Public Function LoadCallBack(ByVal dwCookie As Long, ByVal lPtrPbBuff As Long, ByVal cb As Long, ByVal pcb As Long) As Long
    ReadFile dwCookie, ByVal lPtrPbBuff, cb, ByVal pcb, ByVal 0&
    LoadCallBack = 0
End Function

